%bcond_without gtk3
%bcond_without js

%define desktop_vendor  atrpms
%define _pkgbuilddir %{_builddir}/%{name}_%{version}

Summary:   Graphical video editing tool
Name:      avidemux
Version:   2.6.4
Release:   2%{?dist}
License:   GPLv2+
Group:     Applications/Multimedia
URL:       http://www.avidemux.org
Source0:   http://downloads.sourceforge.net/%{name}/%{name}_%{version}.tar.gz
Source1:   %{name}-qt.desktop
Source2:   %{name}-gtk.desktop

Patch1:    avidemux-2.6-bundled_libs.patch
Patch2:    avidemux3-libass.patch
Patch3:    avidemux3-bundled_libs.patch
Patch4:    avidemux-2.6.4-gtk_fix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: cmake
BuildRequires: gcc-c++, gcc
BuildRequires: libxml2-devel >= 2.6.8
BuildRequires: qt4-devel >= 4.7.0
%{?with_gtk3:BuildRequires: gtk3-devel}
BuildRequires: cairo-devel
#BuildRequires: nasm >= 0.98.32
BuildRequires: desktop-file-utils
BuildRequires: libxslt
# Audio
BuildRequires: libmad-devel
BuildRequires: lame-devel
BuildRequires: twolame-devel
BuildRequires: libogg-devel >= 1.1
BuildRequires: libvorbis-devel
BuildRequires: faad2-devel
BuildRequires: faac-devel
BuildRequires: a52dec-devel
BuildRequires: libdca-devel
# Video
BuildRequires: xvidcore-devel
BuildRequires: x264-devel
BuildRequires: ffmpeg-devel
# Miscellaneous
BuildRequires: freetype-devel
BuildRequires: alsa-lib-devel
BuildRequires: SDL-devel
BuildRequires: libXv-devel
BuildRequires: pulseaudio-libs-devel
BuildRequires: libpng-devel
%{?with_js:BuildRequires: js-devel}
BuildRequires: jack-audio-connection-kit-devel
BuildRequires: libsamplerate-devel
BuildRequires: opencore-amr-devel
BuildRequires: yasm-devel
BuildRequires: libvdpau-devel
BuildRequires: mesa-libGL-devel mesa-libGLU-devel
BuildRequires: libass-devel
BuildRequires: libvpx-devel
BuildRequires: pkgconfig
BuildRequires: sqlite-devel
BuildRequires: libXmu-devel

Requires(post):   /sbin/ldconfig
Requires(postun): /sbin/ldconfig

Provides:      avidemux2 = %{evr}
Obsoletes:     avidemux2 <= %{eversion}

%description
Avidemux is a free video editor designed for simple cutting, filtering
and encoding tasks. It supports many file types, including AVI, DVD
compatible MPEG files, MP4 and ASF, using a variety of codecs. Tasks
can be automated using projects, job queue and powerful scripting
capabilities.

%package devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description devel
This package contains files required to develop with or extend %{name}.

%prep
%setup -q -n %{name}_%{version}

%patch1 -p1 -b .bund_libs
%patch2 -p1 -b .libass
%patch3 -p1 -b .bund_libs2
%patch4 -p1 -b .gtk_fix

# Remove sources of bundled libraries.
rm -rf avidemux_plugins/ADM_audioDecoders/ADM_ad_ac3/ADM_liba52 \
       avidemux_plugins/ADM_audioDecoders/ADM_ad_mad/ADM_libMad \
       avidemux_plugins/ADM_audioEncoders/twolame/ADM_libtwolame \
       avidemux_plugins/ADM_videoFilters6/ass/ADM_libass


%build
# Build avidemux_core
LDFLAGS="-Wl,--as-needed";export LDFLAGS
rm -rf build_core && mkdir build_core && pushd build_core
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       ../avidemux_core
make 
#%{?_smp_mflags}

# We have to do a fake install so header files are avaialble for the other
# packages.
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

# Build cli interface
rm -rf build_cli && mkdir build_cli && pushd build_cli
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       ../avidemux/cli
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

# Build QT4 gui
rm -rf build_qt4 && mkdir build_qt4 && pushd build_qt4
qt_prefix=`pkg-config --variable=exec_prefix QtCore` || :
if [ "$qt_prefix" = "" ]; then
  qt_prefix=`ls -d %{_libdir}/qt4* 2>/dev/null | tail -n 1`
fi

if ! echo ${PATH} | /bin/grep -q $qt_prefix/bin ; then
   PATH=$qt_prefix/bin:${PATH}
fi
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       ../avidemux/qt4
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

%if %{with gtk3}
# Build GTK gui
rm -rf build_gtk && mkdir build_gtk && pushd build_gtk
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       ../avidemux/gtk
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd
%endif

# Build avidemux_plugins_common
rm -rf build_plugins_common && mkdir build_plugins_common && pushd build_plugins_common
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       -DAVIDEMUX_SOURCE_DIR=%{_builddir}/%{name}_%{version} \
       -DPLUGIN_UI=COMMON \
       -DUSE_EXTERNAL_LIBASS=TRUE \
       -DUSE_EXTERNAL_LIBMAD=TRUE \
       -DUSE_EXTERNAL_LIBA52=TRUE \
       -DUSE_EXTERNAL_TWOLAME=TRUE \
       ../avidemux_plugins
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

# Build avidemux_plugins_cli
rm -rf build_plugins_cli && mkdir build_plugins_cli && pushd build_plugins_cli
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       -DAVIDEMUX_SOURCE_DIR=%{_builddir}/%{name}_%{version} \
       -DPLUGIN_UI=CLI \
       -DUSE_EXTERNAL_LIBASS=TRUE \
       -DUSE_EXTERNAL_LIBMAD=TRUE \
       -DUSE_EXTERNAL_LIBA52=TRUE \
       -DUSE_EXTERNAL_TWOLAME=TRUE \
       ../avidemux_plugins
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

# Build avidemux_plugins_qt4
rm -rf build_plugins_qt4 && mkdir build_plugins_qt4 && pushd build_plugins_qt4
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       -DAVIDEMUX_SOURCE_DIR=%{_builddir}/%{name}_%{version} \
       -DPLUGIN_UI=QT4 \
       -DUSE_EXTERNAL_LIBASS=TRUE \
       -DUSE_EXTERNAL_LIBMAD=TRUE \
       -DUSE_EXTERNAL_LIBA52=TRUE \
       -DUSE_EXTERNAL_TWOLAME=TRUE \
       ../avidemux_plugins
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd

%if %{with gtk3}
# Build avidemux_plugins_gtk
rm -rf build_plugins_gtk && mkdir build_plugins_gtk && pushd build_plugins_gtk
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DFAKEROOT=%{_pkgbuilddir}/fakeRoot \
       -DAVIDEMUX_SOURCE_DIR=%{_builddir}/%{name}_%{version} \
       -DPLUGIN_UI=GTK \
       -DUSE_EXTERNAL_LIBASS=TRUE \
       -DUSE_EXTERNAL_LIBMAD=TRUE \
       -DUSE_EXTERNAL_LIBA52=TRUE \
       -DUSE_EXTERNAL_TWOLAME=TRUE \
       ../avidemux_plugins
make %{?_smp_mflags}
make install DESTDIR=%{_pkgbuilddir}/fakeRoot
popd
%endif


%install
make -C build_core install DESTDIR=%{buildroot}
make -C build_cli install DESTDIR=%{buildroot}
make -C build_qt4 install DESTDIR=%{buildroot}
%if %{with gtk3}
make -C build_gtk install DESTDIR=%{buildroot}
%endif
make -C build_plugins_common install DESTDIR=%{buildroot}
make -C build_plugins_cli install DESTDIR=%{buildroot}
make -C build_plugins_qt4 install DESTDIR=%{buildroot}
%if %{with gtk3}
make -C build_plugins_gtk install DESTDIR=%{buildroot}
%endif

# FFMpeg libraries are not being installed as executable.
chmod +x %{buildroot}%{_libdir}/libADM6*.so.*

# Install desktop files
desktop-file-install --vendor %{desktop_vendor} \
    --dir %{buildroot}%{_datadir}/applications \
    %{SOURCE1}

%if %{with gtk3}
desktop-file-install --vendor %{desktop_vendor} \
    --dir %{buildroot}%{_datadir}/applications \
    %{SOURCE2}
%endif

# Install icons
%if %{with gtk3}
install -pDm 0644 avidemux/gtk/ADM_userInterfaces/glade/main/avidemux_icon_small.png \
        %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/avidemux.png
%endif

install -pDm 0644 avidemux_icon.png \
	%{buildroot}%{_datadir}/icons/hicolor/64x64/apps/avidemux.png


%post 
/sbin/ldconfig

/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :

%postun 
/sbin/ldconfig

if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
/usr/bin/update-desktop-database &> /dev/null || :

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%clean
rm -rf %{buildroot}

%files
%doc AUTHORS COPYING README
%dir %{_datadir}/avidemux6
%{_libdir}/libADM*

%{_datadir}/icons/hicolor/*/apps/avidemux.png

%{_libdir}/ADM_plugins6/muxers
%{_libdir}/ADM_plugins6/demuxers
%{_libdir}/ADM_plugins6/audioDevices
%{_libdir}/ADM_plugins6/autoScripts
%{_libdir}/ADM_plugins6/scriptEngines
%{_libdir}/ADM_plugins6/videoFilters
%{_libdir}/ADM_plugins6/videoEncoders
%{_libdir}/ADM_plugins6/videoDecoders
%{_libdir}/ADM_plugins6/audioEncoders
%{_libdir}/ADM_plugins6/audioDecoder

%{_bindir}/avidemux3_cli

%if %{with gtk3}
%{_bindir}/avidemux3_gtk
%{_libdir}/ADM_glade/
%{_datadir}/applications/%{desktop_vendor}-avidemux-gtk.desktop
%endif

%{_bindir}/avidemux3_qt4
%{_bindir}/avidemux3_jobs
%{_datadir}/applications/%{desktop_vendor}-avidemux-qt.desktop

%{_datadir}/avidemux6/help/
%{_datadir}/avidemux6/i18n/

%files devel
%{_includedir}/avidemux/

%changelog
* Wed Jul 17 2013 Paulo Roma <roma@lcg.ufrj.br> - 2.6.4-2
- Conditionally building with js-devel.

* Sat Jun 29 2013 Paulo Roma <roma@lcg.ufrj.br> - 2.6.4-1
- Updated to 2.6.4

* Tue Jan 03 2012 Paulo Roma <roma@lcg.ufrj.br> - 2.5.6-30
- Updated to 2.5.6
- Removed deprecated _fix_lav_audio_encoder.patch and
  x264_i_to_b_open_gop.patch

* Mon Aug 22 2011 Paulo Roma <roma@lcg.ufrj.br> - 2.5.5-29
- Updated to 2.5.5
- Removed deprecated audioDevice.patch,
  and gtk_menu_dont_crash.patch and X264_WEIGHTP_BLIND.patch

* Tue Jan 25 2011 Paulo Roma <roma@lcg.ufrj.br> - 2.5.4-27
- X264_WEIGHTP_BLIND has been replaced for X264_WEIGHTP_SIMPLE.

* Fri Dec 31 2010 Paulo Roma <roma@lcg.ufrj.br> - 2.5.4-26
- Applied avidemux-2.5.4_audioDevice.patch
  QT4 version fails setting audio.
- Applied avidemux-2.5.4-gtk_menu_dont_crash.patch
  If an option is selected in qt4 ui that is not available in gtk, 
  the preference menu will crash

* Sun Dec 19 2010 Paulo Roma <roma@lcg.ufrj.br> - 2.5.4-25
- Updated to 2.5.4
- Removed windows ADM_addons.
- Removed ffmpeg and asm patches.
- Added post and postun sections.

* Sat Nov 13 2010 Paulo Roma <roma@lcg.ufrj.br> - 2.5.3-24
- Patched for asm movq.

* Tue Jun 02 2010 Paulo Roma <roma@lcg.ufrj.br> - 2.5.3-22
- Update to 2.5.3.
- Removed locale and applied mpeg2enc patch.

* Tue Jun 02 2010 Paulo Roma <roma@lcg.ufrj.br> - 2.5.2-21
- Update to 2.5.2.
- Building plugins.

* Tue Nov 17 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.5.1-20
- Update to 2.5.1.

* Fri Jul 17 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.5.0-19
- Update to 2.5.0.

* Fri Jun 19 2009 Paulo Roma <roma@lcg.ufrj.br> - 2.4.4-18
- Patched avidemux/CMakeLists.txt
  http://bugs.gentoo.org/show_bug.cgi?id=268618

* Sun Mar  1 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.4-17
- Update to 2.4.4.

* Mon Dec 01 2008 Paulo Roma <roma@lcg.ufrj.br> - 2.4.3-16
- Applied gentoo patch for libx264:
  http://bugs.gentoo.org/attachment.cgi?id=167706

* Fri Jul 25 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.3-15
- Update to 2.4.3.

* Thu Jul 24 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.2-14
- Update to 2.4.2.

* Mon Jun 09 2008 Paulo Roma <roma@lcg.ufrj.br> - 2.4.1-13
- Patched for building in F9.
- Removed %%{?_smp_mflags} from make.
- Changed in /usr/share/aclocal/po.m4 and /usr/share/aclocal/intl.m4
  AM_PROG_MKDIR_P for AC_PROG_MKDIR_P. Otherwise it does not build.
- Removed cmake call after configure.

* Mon Feb 18 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4.1-12
- Update to 2.4.1.

* Wed Jan  9 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4-11
- Update to 2.4 final.

* Tue Aug  7 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.4-10_preview2
- Update to 2.4_preview2.

* Sun Feb  4 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.3.0-9
- Update to 2.3.0.

* Mon Mar 27 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 2.1.2.

* Tue Jul  5 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 2.0.42.

* Mon Dec 27 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 2.0.34-test2.

* Tue Sep 21 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- cosmetic fixes.

* Tue Sep 21 2004 Gavin Hurlbut <gjhurlbu@beirdo.ca> - 2.0.28-2
- Rebuilt for inclusion in atrpms repository

* Fri Aug 13 2004 Dag Wieers <dag@wieers.com> - 2.0.28-1
- Updated to release 2.0.28.

* Fri Jul 23 2004 Dag Wieers <dag@wieers.com> - 2.0.26-1
- Updated to release 2.0.26.

* Tue May 11 2004 Dag Wieers <dag@wieers.com> - 2.0.24-1
- Updated to release 2.0.24.

* Sat Feb 28 2004 Dag Wieers <dag@wieers.com> - 2.0.22-0
- Updated to release 2.0.22.

* Mon Dec 22 2003 Dag Wieers <dag@wieers.com> - 2.0.20-0
- Updated to release 2.0.20.

* Sun Nov 02 2003 Dag Wieers <dag@wieers.com> - 2.0.18-0
- Updated to release 2.0.18.

* Sun Sep 27 2003 Dag Wieers <dag@wieers.com> - 2.0.16-0
- Updated to release 2.0.16.

* Sat Aug 23 2003 Dag Wieers <dag@wieers.com> - 2.0.14-1
- Rebuild against xvidcore-0.9.2.

* Sun Aug 17 2003 Dag Wieers <dag@wieers.com> - 2.0.14-0
- Updated to release 2.0.14.

* Sun Aug 03 2003 Dag Wieers <dag@wieers.com> - 2.0.12-0
- Updated to release 2.0.12.

* Sat Jun 28 2003 Dag Wieers <dag@wieers.com> - 2.0.8-0
- Updated to release 2.0.8.

* Sun Jun 01 2003 Dag Wieers <dag@wieers.com> - 2.0.6-0
- Updated to release 2.0.6.
- Updated to release 2.0.4.

* Mon Apr 21 2003 Dag Wieers <dag@wieers.com> - 0.9-0
- Updated to release 0.9.

* Sun Mar 23 2003 Dag Wieers <dag@wieers.com> - 0.8.93-0
- Updated to release 0.9rc3.

* Sun Mar 09 2003 Dag Wieers <dag@wieers.com> - 0.8.92-0
- Updated to release 0.9rc2.

* Fri Feb 28 2003 Dag Wieers <dag@wieers.com> - 0.8.91-0
- Updated to release 0.9rc1.

* Sat Feb 08 2003 Dag Wieers <dag@wieers.com> - 0.9pre32
- Initial package. (using DAR)
